' ******************************************************
' *** ***
' *** Reaktiv-Tiny mit Watchdog-Abschaltung und LDR ***
' *** ***
' ******************************************************

$regfile = "ATtiny13.DAT"
$crystal = 16000 			  'Frequenz des internen Oszillators

Config Portb = &B00001001 		 'Pinb.0 und 3 auf 'Ausgang', Rest auf 'Eingang' schalten
Portb = 0
Stop Adc 				  'A/D-Wandler abschalten, um Strom zu sparen
Stop Ac 				   'Analog-Komparator abschalten, um Strom zu sparen

Wdtcr = &B11010011 			'Watchdog definieren: 0.125 Sekunden, Interrupt auslsen, kein Reset
Enable Interrupts 			 'Interrupts freigeben

Dim A As Byte
Dim B As Byte
Dim C As Byte
Dim Ldr As Bit
Dim Hell As Bit
Dim Hell_2 As Byte

Do
	Gosub Ldr_abfrage
	If Ldr = 1 Then 
		Hell = 1 		  'Bei Licht Merker setzen
	End If
	If Hell = 1 And B < 255 Then 
		B = B + 1 		 'Wenn Merker gesetzt wurde, Zhler fr Lichtdauer erhhen (bis max. 255)
	End If
	If B > 200 Then 
		Gosub Abschalten 	  'Schlafmodus wenn es zu lange am Stck hell ist
	End If
	If Ldr = 0 And Hell = 1 And B < 30 Then 'Wenn es wieder dunkel ist und der Lichtimpuls nur kurz war
		Hell_2 = 0 		'zweiten Hell-Merker setzen
		For C = 0 To 5 	    'und 5 mal abfragen
			Gosub Ldr_abfrage
			If Ldr = 1 Then 
				Hell_2 = Hell_2 + 1 'ob es auch wieder dunkel ist
			End If
		Next C
		If Hell_2 = 0 Then 
			Gosub Blinken      'erst dann blinken
		End If
		Hell = 0
		B = 0
	End If
	If Ldr = 0 Then 		   'Bei Dunkelheit Merker und Zhler fr Lichtdauer lschen
		Hell = 0 		  'damit sich das Programm nicht aufhngt
		B = 0
	End If
Loop

Ldr_abfrage:
	Portb.0 = 1 		       'Spannung auf LDR geben
	Reset Watchdog 		    'Kurz warten bis sich alles eingeschwungen hat
	Powerdown
	Ldr = Pinb.4 		      'LDR abfragen
	Portb.0 = 0 		       'Spannung von LDR wieder wegnehmen
Return

Blinken: 				  'LED blinken lassen
	For A = 1 To 10
		Portb.3 = 1
		Reset Watchdog
		Powerdown
		Portb.3 = 0
		Reset Watchdog
		Powerdown
	Next A
Return

Abschalten: 			       'Prozessor fr 8 Sekunden schlafen lassen
	Wdtcr = &B11110001
	Reset Watchdog
	Powerdown
	Wdtcr = &B11010011
Return

End